// OptionDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinWol.h"
#include "OptionDlg.h"
#include "afxdialogex.h"


// COptionDlg _CAO

IMPLEMENT_DYNAMIC(COptionDlg, CDialog)

COptionDlg::COptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlg::IDD, pParent)
	, m_TimeOut(300)
	, m_PortNo(7)
	, m_MaxHostNum(100)
	, m_TimerInterval(60)
	, m_InitRefresh(TRUE)
	, m_NoExternCmd(FALSE)
	, m_CheckNetworkSegment(FALSE)
	, m_CheckAutoRefresh(TRUE)
	, m_nActiveMarkType(0)
	, m_MarkText(_T(""))
{
	m_ActiveFgColor = RGB(255, 0, 0);
	m_ActiveBgColor = RGB(0, 255, 0);
	m_ActiveImgMaskColor = RGB(0, 0, 255);
}

COptionDlg::~COptionDlg()
{
}

void	COptionDlg::SetData(tOption Data)
{
	m_TimeOut = Data.uiTimeOut;
	m_PortNo = Data.uiPortNo;
	m_MaxHostNum = Data.uiMaxHostNum;
	m_InitRefresh = Data.bInitRefresh;
	m_NoExternCmd = Data.bNoExternCmd;
	m_CheckNetworkSegment = Data.bCheckNetworkSegment;
	m_CheckAutoRefresh = Data.bAutoRefresh;
	m_TimerInterval = Data.uiTimerInterval;
	m_ActiveFgColor = Data.ActiveFgColor;
	m_ActiveBgColor = Data.ActiveBgColor;
	m_ActiveImgMaskColor = Data.ActiveImgMaskColor;
	m_MarkText = Data.sActiveMarkStr;
	if (Data.nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
		m_nActiveMarkType = 0;
	} else {
		m_nActiveMarkType = 1;
	}
	if (IsWindow(GetSafeHwnd())) {
		UpdateData(FALSE);
	}
}

void	COptionDlg::GetData(tOption &Data)
{
	if (IsWindow(GetSafeHwnd())) {
		UpdateData(TRUE);
	}
	Data.uiTimeOut = m_TimeOut;
	Data.uiPortNo = m_PortNo;
	Data.uiMaxHostNum = m_MaxHostNum;
	Data.bInitRefresh = m_InitRefresh;
	Data.bNoExternCmd = m_NoExternCmd;
	Data.bCheckNetworkSegment = m_CheckNetworkSegment;
	Data.bAutoRefresh = m_CheckAutoRefresh;
	Data.uiTimerInterval = m_TimerInterval;
	Data.ActiveFgColor = m_ActiveFgColor;
	Data.ActiveBgColor = m_ActiveBgColor;
	Data.ActiveImgMaskColor = m_ActiveImgMaskColor;
	Data.sActiveMarkStr = m_MarkText;
	if (m_nActiveMarkType == 0) {
		Data.nActiveMarkType = ACTIVE_MARK_TYPE_ICON;
	} else {
		Data.nActiveMarkType = ACTIVE_MARK_TYPE_TEXT;
	}
}


void COptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_TIMEOUT, m_TimeOut);
	DDV_MinMaxUInt(pDX, m_TimeOut, 1, 10000);
	DDX_Text(pDX, IDC_EDIT_PORT_NO, m_PortNo);
	DDV_MinMaxUInt(pDX, m_PortNo, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_MAX_HOST_NUM, m_MaxHostNum);
	DDV_MinMaxUInt(pDX, m_MaxHostNum, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_TIMER_INTERVAL, m_TimerInterval);
	DDV_MinMaxUInt(pDX, m_TimerInterval, 10, 65535);
	DDX_Check(pDX, IDC_CHECK_INIT_REFRESH, m_InitRefresh);
	DDX_Check(pDX, IDC_NO_EXTERN_COMMAND, m_NoExternCmd);
	DDX_Check(pDX, IDC_CHECK_NETWORK_SEGMENT, m_CheckNetworkSegment);
	DDX_Check(pDX, IDC_CHECK_AUTO_REFRESH, m_CheckAutoRefresh);
	DDX_Control(pDX, IDC_PICT_ACTIVE_HOST_BG_COLOR, m_PictActiveBgColor);
	DDX_Control(pDX, IDC_PICT_ACTIVE_HOST_FG_COLOR, m_PictActiveFgColor);
	DDX_Radio(pDX, IDC_RADIO_ACTIVE_MARK_TYPE1, m_nActiveMarkType);
	DDV_MinMaxInt(pDX, m_nActiveMarkType, 0, 1);
	DDX_Control(pDX, IDC_STATIC_ACTIVE_MARK_TYPE_BG, m_StActiveColorBG);
	DDX_Control(pDX, IDC_STATIC_ACTIVE_MARK_TYPE_FG, m_StActiveColorFG);
	DDX_Control(pDX, IDC_STATIC_MARK_TEXT, m_StMarkText);
	DDX_Text(pDX, IDC_EDIT_MARK_TEXT, m_MarkText);
	DDX_Control(pDX, IDC_EDIT_MARK_TEXT, m_EditMarkText);
}


BEGIN_MESSAGE_MAP(COptionDlg, CDialog)
	ON_STN_CLICKED(IDC_PICT_ACTIVE_HOST_BG_COLOR, &COptionDlg::OnStnClickedPictActiveHostBgColor)
	ON_STN_CLICKED(IDC_PICT_ACTIVE_HOST_FG_COLOR, &COptionDlg::OnStnClickedPictActiveHostFgColor)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_RADIO_ACTIVE_MARK_TYPE1, &COptionDlg::OnBnClickedRadioActiveMarkType1)
	ON_BN_CLICKED(IDC_RADIO_ACTIVE_MARK_TYPE2, &COptionDlg::OnBnClickedRadioActiveMarkType2)
END_MESSAGE_MAP()


// COptionDlg bZ[W nh[


BOOL COptionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
	UpdateData(FALSE);

	if (m_nActiveMarkType == 0) {
		m_StActiveColorBG.EnableWindow(FALSE);
		m_StActiveColorFG.EnableWindow(FALSE);
		m_PictActiveBgColor.EnableWindow(FALSE);
		m_PictActiveFgColor.EnableWindow(FALSE);
		m_StMarkText.EnableWindow(FALSE);
		m_EditMarkText.EnableWindow(FALSE);
	} else {
		m_StActiveColorBG.EnableWindow(TRUE);
		m_StActiveColorFG.EnableWindow(TRUE);
		m_PictActiveBgColor.EnableWindow(TRUE);
		m_PictActiveFgColor.EnableWindow(TRUE);
		m_StMarkText.EnableWindow(TRUE);
		m_EditMarkText.EnableWindow(TRUE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void COptionDlg::OnOK()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	UpdateData(TRUE);

	CDialog::OnOK();
}


void COptionDlg::OnStnClickedPictActiveHostBgColor()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	CColorDialog	dlg(m_ActiveBgColor);

	if (dlg.DoModal() == IDOK) {
		m_ActiveBgColor = dlg.GetColor();

		Invalidate(FALSE);
	}
}

void COptionDlg::OnStnClickedPictActiveHostFgColor()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	CColorDialog	dlg(m_ActiveFgColor);

	if (dlg.DoModal() == IDOK) {
		m_ActiveFgColor = dlg.GetColor();

		Invalidate(FALSE);
	}
}

void COptionDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ɃbZ[W nh[ R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB
	if (m_nActiveMarkType == 1) {
		CRect	rect;

		m_PictActiveBgColor.GetWindowRect(&rect);

		ScreenToClient(&rect);

		dc.FillSolidRect(rect.left, rect.top, rect.Width(), rect.Height(), m_ActiveBgColor);

		m_PictActiveFgColor.GetWindowRect(&rect);

		ScreenToClient(&rect);

		dc.FillSolidRect(rect.left, rect.top, rect.Width(), rect.Height(), m_ActiveFgColor);
	}
}


void COptionDlg::OnBnClickedRadioActiveMarkType1()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	UpdateData(TRUE);

	if (m_nActiveMarkType == 0) {
		m_StActiveColorBG.EnableWindow(FALSE);
		m_StActiveColorFG.EnableWindow(FALSE);
		m_PictActiveBgColor.EnableWindow(FALSE);
		m_PictActiveFgColor.EnableWindow(FALSE);
		m_StMarkText.EnableWindow(FALSE);
		m_EditMarkText.EnableWindow(FALSE);
	} else {
		m_StActiveColorBG.EnableWindow(TRUE);
		m_StActiveColorFG.EnableWindow(TRUE);
		m_PictActiveBgColor.EnableWindow(TRUE);
		m_PictActiveFgColor.EnableWindow(TRUE);
		m_StMarkText.EnableWindow(TRUE);
		m_EditMarkText.EnableWindow(TRUE);
	}
	Invalidate();
}


void COptionDlg::OnBnClickedRadioActiveMarkType2()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	UpdateData(TRUE);

	if (m_nActiveMarkType == 0) {
		m_StActiveColorBG.EnableWindow(FALSE);
		m_StActiveColorFG.EnableWindow(FALSE);
		m_PictActiveBgColor.EnableWindow(FALSE);
		m_PictActiveFgColor.EnableWindow(FALSE);
		m_StMarkText.EnableWindow(FALSE);
		m_EditMarkText.EnableWindow(FALSE);
	} else {
		m_StActiveColorBG.EnableWindow(TRUE);
		m_StActiveColorFG.EnableWindow(TRUE);
		m_PictActiveBgColor.EnableWindow(TRUE);
		m_PictActiveFgColor.EnableWindow(TRUE);
		m_StMarkText.EnableWindow(TRUE);
		m_EditMarkText.EnableWindow(TRUE);
	}
	Invalidate();
}
