// [eBeB֐
// util.cpp

#include	"stdafx.h"

#include	"util.h"
#include	"stdarg.h"

static	char	strErrMsg[4096];

// wt@C̃fBNg𓾂
LPTSTR	GetFileDir(LPCTSTR lpFileName, LPTSTR lpDirBuf, DWORD dwMaxLen)
{
	TCHAR	*pFileName;

	//t@C̃tpXƂ̃t@Cvf̈ʒu𓾂
	if (GetFullPathName(lpFileName, dwMaxLen,
								lpDirBuf, &pFileName) > 0) {
		if (pFileName) {
			//fBNgpX̋؂蕶菜
			if (pFileName > lpDirBuf) {
				*(pFileName - 1) = NULL;
			}
			//t@Cvf؂藎Ƃ
			*pFileName = NULL;
		}
		return lpDirBuf;
	}
	return NULL;
}

//vŐNfBNg𓾂
int GetModuleDir(LPTSTR dir, int max_len)
{
	TCHAR	module_fname[MAX_PATH];
	TCHAR	full_path[MAX_PATH];
	TCHAR	*pFile;

	GetModuleFileName(NULL, module_fname, sizeof(module_fname)/sizeof(TCHAR) - 1);
	GetFullPathName(module_fname, sizeof(full_path)/sizeof(TCHAR), full_path, &pFile);
	if (pFile) {
		*pFile = NULL;
	}
	_tcsncpy_s(dir, max_len - 1, full_path, _TRUNCATE);
	dir[max_len - 1] = NULL;

	return _tcsnlen(dir, max_len);
}

// ݒt@C̃tpX擾
LPCTSTR GetIniFileName(LPCTSTR pBaseName, LPCTSTR pExt,
								LPTSTR pIniFileName, int nMaxLen)
{
	TCHAR	buf[MAX_PATH];
	char	path[MAX_PATH];
	char	*pFile;

	if (GetModuleFileName(NULL, buf, sizeof(buf)/sizeof(TCHAR)) > 0) {
		if (GetFullPathName(buf, sizeof(path)/sizeof(TCHAR), path, &pFile) > 0) {
			if (pFile) {
				*pFile = NULL;
			}
			_stprintf_s(pIniFileName, nMaxLen, "%s\\%s.%s", path, pBaseName, pExt);
		} else {
			_stprintf_s(pIniFileName, nMaxLen, "%s\\%s.%s", buf, pBaseName, pExt);
		}
	} else {
		_stprintf_s(pIniFileName, nMaxLen, "%s.%s", pBaseName, pExt);
	}
	return pIniFileName;
}

//vÕo[W𓾂
bool	GetVersionVal(WORD *pMsH, WORD *pMsL, WORD *pLsH, WORD *pLsL)
{
	TCHAR	fname[MAX_PATH];
	DWORD	dwHandle = 0;
	DWORD	dwSize;
	bool	ret = false;

	GetModuleFileName(NULL, fname, sizeof(fname)/sizeof(TCHAR));

	if ((dwSize = GetFileVersionInfoSize(fname, &dwHandle)) > 0) {
		BYTE	*pVerInfo = new BYTE[dwSize];
		if (GetFileVersionInfo(fname, NULL, dwSize, pVerInfo)) {
			VS_FIXEDFILEINFO	*pInfo;
			UINT				len;

			if (VerQueryValue(pVerInfo, _T("\\"), (LPVOID *)&pInfo, &len)) {
				if (pMsH) {
					*pMsH = (WORD)((pInfo->dwFileVersionMS >> 16) & 0xffff);
				}
				if (pMsL) {
					*pMsL = (WORD)(pInfo->dwFileVersionMS & 0xffff);
				}
				if (pLsH) {
					*pLsH = (WORD)((pInfo->dwFileVersionLS >> 16) & 0xffff);
				}
				if (pLsL) {
					*pLsL = (WORD)(pInfo->dwFileVersionLS & 0xffff);
				}
				ret = true;
			}
		}
		delete[] pVerInfo;
	}
	return ret;
}

//vÕo[W𓾂
DWORD	GetVersionVal(void)
{
	WORD	wVer[4];
	DWORD	dwVer = 0;

	if (GetVersionVal(&wVer[0], &wVer[1], &wVer[2], &wVer[3])) {
		dwVer = (((DWORD)wVer[0] << 24) | ((DWORD)wVer[1] << 16) | ((DWORD)wVer[2] << 8) | (DWORD)wVer[3]);
	}
	return dwVer;
}

// vÕo[W̕𓾂
BOOL	GetVersionInfo(LPTSTR pStr, int MaxLen, LPCTSTR pKey)
{
	TCHAR	fname[MAX_PATH];
	DWORD	dwHandle = 0;
	DWORD	dwSize;
	BOOL	ret = FALSE;

	GetModuleFileName(NULL, fname, sizeof(fname)/sizeof(TCHAR));

	if ((dwSize = GetFileVersionInfoSize(fname, &dwHandle)) > 0) {
		BYTE	*pVerInfo = new BYTE[dwSize];
		if (GetFileVersionInfo(fname, NULL, dwSize, pVerInfo)) {
			UINT				len;
			DWORD				*dwTrans;

			if (VerQueryValue(pVerInfo, "\\VarFileInfo\\Translation", (LPVOID *)&dwTrans, &len)) {
				CString	sPath;
				char	*pValue;

				sPath.Format("\\StringFileInfo\\%04x%04x\\%s",
								LOWORD(*dwTrans), HIWORD(*dwTrans), pKey);
				if (VerQueryValue(pVerInfo, sPath, (void **)&pValue, &len)) {
					_tcsncpy_s(pStr, MaxLen - 1, pValue, _TRUNCATE);
					ret = TRUE;
				}
			}
		}
		delete[] pVerInfo;
	}
	return ret;
}

// vÕRs[Cg𓾂
BOOL	GetCopyrightStr(LPTSTR pCopyright, int MaxLen)
{
	return GetVersionInfo(pCopyright, MaxLen, "LegalCopyright");
}

// G[bZ[W擾
LPCTSTR	GetErrorString(DWORD dwErr)
{
	LPVOID lpMsgBuf;

	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
	    FORMAT_MESSAGE_IGNORE_INSERTS,
	    NULL,
	    dwErr,
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
	    (LPTSTR) &lpMsgBuf,
	    0,
	    NULL 
	);
	strncpy_s(strErrMsg, sizeof(strErrMsg), (LPCTSTR)lpMsgBuf, sizeof(strErrMsg)-1);
	strErrMsg[sizeof(strErrMsg)-1] = '\0';

	LocalFree( lpMsgBuf );

	return (LPCTSTR)strErrMsg;
}

//bZ[W|v
void DoEvents(HWND hWnd)
{
    MSG msg;

	if (::GetMessage(&msg, hWnd, NULL, NULL)) {
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
}

// OR}hs
int		RunCommand(LPTSTR szCmd, bool bShowWnd, bool bWait)
{
	PROCESS_INFORMATION	pi;
	STARTUPINFO			si;
	int					ret = 0;

	GetStartupInfo(&si);

	if (!bShowWnd) {
		//R}hvvgEBhEô}~
		si.dwFlags = STARTF_USESHOWWINDOW;
		si.wShowWindow = SW_HIDE;
	}
	if (!CreateProcess(NULL, szCmd, NULL, NULL, FALSE,
					NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi)) {
		ret = -1;
	} else {
		if (bWait) {
			DWORD	exitcode;

			::WaitForSingleObject(pi.hProcess, INFINITE);

			GetExitCodeProcess(pi.hProcess, &exitcode);

			ret = (int)exitcode;
		}
	}

	return ret;
}

//Nbv{[hɕf[^Zbg
BOOL	SetToClipBoard(LPCTSTR lpszText)
{
	HGLOBAL	hMem;
	LPTSTR	pMem;
	int		len;

	if (!lpszText || !(*lpszText)) {
		return FALSE;
	}
	if (!::OpenClipboard(NULL)) {
		return FALSE;
	}
	len = strlen(lpszText);

	hMem = ::GlobalAlloc(GMEM_FIXED, len + 1);
	if (!hMem) {
		return FALSE;
	}
	pMem = (LPTSTR)hMem;
	memcpy(pMem, lpszText, len + 1);
	
	::EmptyClipboard();
	::SetClipboardData(CF_TEXT, hMem);

	::CloseClipboard();

	return TRUE;
}

//Nbv{[h當f[^o
int		GetFromClipBoard(LPTSTR *ppStr)
{
	HGLOBAL	hMem;
	LPTSTR	pMem;
	int		len;
	LPTSTR	pStr;

	*ppStr = NULL;

	if (!::IsClipboardFormatAvailable(CF_TEXT)) {
		return 0;
	}
	if (!::OpenClipboard(NULL)) {
		return -1;
	}
	hMem = ::GetClipboardData(CF_TEXT);
	if (!hMem) {
		return -1;
	}
	len = GlobalSize(hMem);
	try {
		pStr = (LPTSTR)malloc(len);
		if (!pStr) {
			::CloseClipboard();
			return -1;
		}
	} catch(...) {
		::CloseClipboard();
		return -1;
	}
	pMem = (LPTSTR)::GlobalLock(hMem);
	if (!pMem) {
		free(pStr);
		return -1;
	}
	memcpy(pStr, pMem, len);

	::GlobalUnfix(hMem);
	::CloseClipboard();

	*ppStr = pStr;

	return len;
}

//Nbv{[hof[^J
void	ReleaseClipBoardData(LPTSTR pStr)
{
	if (pStr) {
		free(pStr);
	}
}

//tH[}bgtfobOo
void	OutputFmtDbgStr(LPCTSTR lpFmt, ...)
{
	va_list ap;
	char    buf[1024];

	va_start(ap, lpFmt);
    
	vsprintf_s(buf, sizeof(buf), lpFmt, ap);
	
	va_end(ap);

	OutputDebugString(buf);
}
